zoukankan      html  css  js  c++  java
  • Leetcode: Find K Pairs with Smallest Sums

    You are given two integer arrays nums1 and nums2 sorted in ascending order and an integer k.
    
    Define a pair (u,v) which consists of one element from the first array and one element from the second array.
    
    Find the k pairs (u1,v1),(u2,v2) ...(uk,vk) with the smallest sums.
    
    Example 1:
    Given nums1 = [1,7,11], nums2 = [2,4,6],  k = 3
    
    Return: [1,2],[1,4],[1,6]
    
    The first 3 pairs are returned from the sequence:
    [1,2],[1,4],[1,6],[7,2],[7,4],[11,2],[7,6],[11,4],[11,6]
    Example 2:
    Given nums1 = [1,1,2], nums2 = [1,2,3],  k = 2
    
    Return: [1,1],[1,1]
    
    The first 2 pairs are returned from the sequence:
    [1,1],[1,1],[1,2],[2,1],[1,2],[2,2],[1,3],[1,3],[2,3]
    Example 3:
    Given nums1 = [1,2], nums2 = [3],  k = 3 
    
    Return: [1,3],[2,3]
    
    All possible pairs are returned from the sequence:
    [1,3],[2,3]

    Better Solution: O(KlogK), 转自https://discuss.leetcode.com/topic/50885/simple-java-o-klogk-solution-with-explanation

    Some observations: For every numbers in nums1, its best partner(yields min sum) always strats from nums2[0] since arrays are all sorted;

    Frist, we take the first k elements of nums1 and paired with nums2[0] as the starting pairs so that we have (0,0), (1,0), (2,0),.....(k-1,0) in the heap.
    Each time after we pick the pair with min sum, we put the new pair with the second index +1. ie, pick (0,0), we put back (0,1). Therefore, the heap alway maintains at most min(k, len(nums1)) elements.

    For each pair, we need to keep track of its position in nums2[], if the position is greater than or equal to nums2's size, no need to put back new pair with second index+1

    Below is also a good way to define heap

    PriorityQueue<int[]> queue = new PriorityQueue<>((a,b)->a[0]+a[1]-b[0]-b[1]); 

     1 public class Solution {
     2     public List<int[]> kSmallestPairs(int[] nums1, int[] nums2, int k) {
     3         PriorityQueue<int[]> queue = new PriorityQueue<int[]>(k, new Comparator<int[]>() {
     4             public int compare(int[] a, int[] b) {
     5                 return (a[0]+a[1])-(b[0]+b[1]);
     6             }
     7         });
     8         
     9         //PriorityQueue<int[]> queue = new PriorityQueue<>((a,b)->a[0]+a[1]-b[0]-b[1]);
    10         
    11         List<int[]> res = new ArrayList<int[]>();
    12         if (nums1.length==0 || nums2.length==0 || k==0) return res;
    13         for (int i=0; i<nums1.length && i<k; i++) {
    14             queue.offer(new int[]{nums1[i], nums2[0], 0});
    15         }
    16         for (int i=0; i<k && !queue.isEmpty(); i++) {
    17             int[] cur = queue.poll();
    18             res.add(new int[]{cur[0], cur[1]});
    19             if (cur[2]+1 < nums2.length) {
    20                 queue.offer(new int[]{cur[0], nums2[cur[2]+1], cur[2]+1});
    21             }
    22         }
    23         return res;
    24     }
    25 }
  • 相关阅读:
    Eugene and an array CodeForces
    Kind Anton CodeForces
    浙江大学PAT上机题解析之1011. World Cup Betting (20)
    九度OnlineJudge之1001:A+B for Matrices
    九度OnlineJudge之1468:Sharing
    九度OnlineJudge之1464:Hello World for U
    C++ STL 学习笔记
    浙江大学PAT上机题解析之1009. Product of Polynomials (25)
    浙江大学PAT上机题解析之1050. String Subtraction (20)
    浙江大学PAT上机题解析之1008. Elevator (20)
  • 原文地址:https://www.cnblogs.com/EdwardLiu/p/6108127.html
Copyright © 2011-2022 走看看